

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define PROGNAME	"MidiSteuerung"	
#define DATUM		"10.02.2010"	
#define VERSION		"V 1.0"
#define	AUTOR		"Christof Ermer"

//SYSINFO

/* 
WEBSseiten zum Thema Midi
http://ucapps.de/
http://www.serasidis.gr/
*/

/*
HYSTORY 
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

/*
#define UART_BAUD_RATE	9600
#define F_CPU	16000000
*/

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
#include <compat\deprecated.h>
#include <avr\wdt.h>
//Produziert Fehler...
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "main.h"		//with Hardware assigns
#include "uart.h"
#include "Midi.h"
#include "SWUart.h"
#include "In74165.h"



int32_t Round(double fIn);
void ScanSensor(void);

#ifdef TIMER2_TICK_USED
void StartTimer2(void);	//0.1 Seconds  interrupt
int32_t GetTickDifference(uint32_t u32Time);
#endif


#ifdef UART_USE_ENABLED
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void LongToNumStr(int32_t lVal);
void FloatToNumStr(double fVal);
void PrintCR(void);
void PrintStrCR(const char* pStr);
void Print_PStrCR(PGM_P pmStr);
void PrintLongCR(int32_t lVal);
void PrintFloatCR(double fVal);

void CheckOrder(char* pcStr);
#endif


///CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_VERSION[] PROGMEM = VERSION;

#ifdef TEXT_SERVICE_USE_ENABLED 
const char MCA_PROG_NAME[] PROGMEM = PROGNAME;
const char MCA_DATUM[] PROGMEM = DATUM;
const char MCA_VERSION[] PROGMEM = VERSION;
const char MCA_AUTOR[] PROGMEM = AUTOR;

const char MCA_CRSTR[] PROGMEM = {13,0};
const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
#endif


#ifdef UART_ERRORMSG 
const char MCA_UARTErr_MSG[] PROGMEM = "UartEr";
#endif

// GLOBALE VARIABLEN 
//MSG
const char MCA_SPACE_MSG[] PROGMEM	= " ";
const char MCA_ISTGLEICH_MSG[] PROGMEM	= "=";
const char MCA_STERN_MSG[] PROGMEM	= "*";
const char MCA_VALUE_MSG[] PROGMEM	= "Value";
const char MCA_OK_MSG[] PROGMEM	= "OK";


#ifdef UART_USE_ENABLED 
char* gpcRxPars;
char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
char gcaNumStr[NUMMAX + 1]; //+1 for the 0
char gcaStr[STRMAX + 1]; //+1 for the 0
COMMAND_TYPE gsCmd;
#endif


uint8_t gu8ProgMode;
//MIDISTAT uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
volatile  uint32_t gu32T2_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
#ifdef USE_ERROR_FLAG 
uint8_t gbErrorFlag;
#endif

KEYSTRUCT_TYPE gstKey;

#ifdef TIMER2_TICK_USED 
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL( TIMER2_OVF_vect ) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
sei();
//cli();/ 
gu32T2_Ticks++;
#ifdef UART_USE_ENABLED
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif

	

// *************************************
void StartTimer2(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2)));
TIMSK &= ~( TIMSK_TOIE2_FLAG | TIMSK_OCIE2_FLAG );
gu32T2_Ticks = OCR2 = TCNT2 = 0;  //Timer MAX = TOP Compare
//ASSR &= ~(_BV(AS2)); //ASS2  CLOCK FREIGABE von QUARZ
//SFIOR |= PSR2; //RESET COUNTER
//8 Bit Timerx00);	//Timer Inhalt
// 16 MHZ  / 64 = 250000
//250000 / 256 = 3906,25  Intterrupts / Sekunde
//(1/3906,25)  = 0,000256 =  Zeit in Sek/ Interrupt
// SYSCLK_256 / 64 =  675 = 0,0014814814814814814814814814814815   mS Interrrupt
//TIMER STARTS with Presscale Select = 64
TIFR |= TIFR_OCF2_OUTP_COMPARE_FLAG | TIFR_TOV2_TIMER_OVERFLOW_FLAG ; // zum lschen setzen!
//TIMER STARTS with Presscale Select = 64
TCCR2 = TCCR2_CLK_256;	// 0000 0100//Timer Counter CTRL -- NORMAL MODE=NO OCR2
//TCCR2 = TCCR2_CLK_0;	//
TIMSK |= TIMSK_TOIE2_FLAG; //_BV(TOIE2); // BESSER == OVERFLOW 
SREG = sreg;
sei();
};


// ****************************************************************
int32_t GetTickDifference(uint32_t u32Time)
// ****************************************************************
{
return (gu32T2_Ticks - u32Time);
};


// *************************************
void Timer_Init(void) 
// *************************************
/* initialize timer 2 */
{
// obsolte in neuer Version timer_enable_int(0);// outp(0, TIMSK);	/* disable timer interrupts */
timer_enable_int(0);// outp(0, TIMSK);	/* disable timer interrupts */
StartTimer2();	//8 Bit Timer 2 = MS Tick Counter
};



#ifdef UART_USE_ENABLED 
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef UART_ERRORMSG 
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCR(  MCA_UARTErr_MSG );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif




#ifdef UART_USE_ENABLED 
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#ifdef UART_USE_ENABLED   //MAKLEFILE ANPASSEN
// *******************************************************************
void PrintCR(void)
// *******************************************************************
{
uart_puts_p( MCA_CRSTR );
};


// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCR();
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCR();
};


// **********************************************
void FloatToNumStr(double fVal)
// *************
{
sprintf(gcaNumStr,"%.1f", fVal);
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{
//sprintf(gcaNumStr,"%ld", lVal);  //Ulong = %ld
sprintf(gcaNumStr,"%li", lVal);  //Ulong = %ld
};


// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};
#endif



// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, PSTR(",")); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)//Trenne CMD, von ID, -"$$$1,CMD
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10


//strcpy(gcaStr, pcStrOrder);

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

//========================================================================================

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING"))  )
	{	
	Print_PStrCR( PSTR("PONG") );	
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PCR"))  )
	{	
	PrintCR();	
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SPC")) ) 
	{
	DDRC=0XFF; //OUTPUTs
	PORTC = (uint8_t)gsCmd.fCmdVal_1;
	};

if( !strcasecmp_P( gsCmd.ucaCmd,PSTR("RPC")) ) 
	{
	DDRC=0X00; //INPUTs
	PORTC = 0X00; // PullUp AUS	
	PrintLongCR( PINC );
	};	
	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TESTON")  )) 
	{	
	gu8ProgMode |= MODE_TEST_KLAVIERTON;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TESTOFF")  ) )	
	{	
	gu8ProgMode &= ~MODE_TEST_KLAVIERTON	;
	};
	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TSTSHIFTON")  ))
	{	
	gu8ProgMode |= MODE_TEST_SHIFTBORD;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TSTSHIFTOFF")  ) )
	{	
	gu8ProgMode &= ~MODE_TEST_SHIFTBORD;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("NOTE")  ) )
	{	
	SendMidi_ON( (uint8_t)gsCmd.fCmdVal_1) ;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("NOTEOFF")  ) )
	{	
	SendMidi_OFF( (uint8_t)gsCmd.fCmdVal_1) ;
	};


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INST") ) ) 
	{
	TxMidi_ProgChange( (uint8_t)gsCmd.fCmdVal_1);
	uart_puts_p( PSTR("INSTRUMENT=") );
	PrintLongCR( gstMidi.u8Intrument );		
	};
	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("VELO") ) ) //Tonleiterwechsel
	{
	gstMidi.u8Dynamic = (uint8_t)gsCmd.fCmdVal_1;
	uart_puts_p( PSTR("Velocity=") );
	PrintLongCR( gstMidi.u8Dynamic );		
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SCALA") ) ) //Tonleiterwechsel
	{
	if( (uint8_t)gsCmd.fCmdVal_1 == 0 )
		{
		gu8MidiStatus = STATUS_CHROMATISCH;
		};
	if( (uint8_t)gsCmd.fCmdVal_1 == 1 )
		{
		gu8MidiStatus = STATUS_DUR;
		};		
	uart_puts_p( PSTR("Tonleiter=") );
	PrintLongCR( gu8MidiStatus );		
	};
	
/*	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TXSU"))  )
	{	
	SWuart_putc( (uint8_t)gsCmd.fCmdVal_1 );	
	};

*/
 };



// *************************************
void ScanSensor(void)
// *************************************
{
//static uint64_t u64OldVal;
gsKlavier.u64Note = ScanInShift74165();

if( (gsKlavier.u64Note & 0xFFUL) != (gsKlavier.u64OldState & 0xFFUL) )	//1. Byte
	{
	PORTC = gsKlavier.u64Note & (0XFF);
	};
if( (gsKlavier.u64Note & 0xFF00UL) != (gsKlavier.u64OldState & 0xFF00UL) ) //2. Byte
	{
	PORTC = (gsKlavier.u64Note >> 8) & (0xFF);
	};
if( (gsKlavier.u64Note & 0xFF0000UL) != (gsKlavier.u64OldState & 0xFF0000UL) ) //3. Byte
	{
	PORTC = (gsKlavier.u64Note >> 16) & (0xFF);
	};
if( (gsKlavier.u64Note & 0xFF000000UL) != (gsKlavier.u64OldState & 0xFF000000UL) ) //4. Byte
	{
	PORTC = (gsKlavier.u64Note >> 24) & (0xFF);
	};
if( (gsKlavier.u64Note & 0xFF00000000ULL) != (gsKlavier.u64OldState & 0xFF00000000ULL) ) //5. Byte
	{
	PORTC = (gsKlavier.u64Note >> 32) & (0xFF);
	};
};



// *******************************************************************
int main(void)
// *******************************************************************
{
static uint32_t ullNow;
static uint8_t u8Toggle;
//float fVal1, fVal2,fVal3,fVal4, fVal5, fVal6;
//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRA = PORTA_DDRX_OUTMASK;
PORTA = PORTA_PRESET_PULLMASK;
DDRB = PORTB_DDRX_OUTMASK;
PORTB = PORTB_PRESET_PULLMASK;
DDRC = PORTC_DDRX_OUTMASK;
PORTC = PORTC_PRESET_PULLMASK;
DDRD = PORTD_DDRX_OUTMASK;	
PORTD = PORTD_PRESET_PULLMASK;
//SFIOR = (1<<PUD); //Pullup Disable

//INTERRUPT MODE EiNSTELLEMN;
StartTimer2();	//8 Bit Timer 2 = MS Tick Counter
// ZUM LESEN IMMER PINx verwenden
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE

ResetRxBuff();
// Initialize UART library, pass baudrate and avr cpu clock
//  with the macro UART_BAUD_SELECT()
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
SWuart_init( ); //BAUDRATE 31250

INIT_74165PORTDIR();


Print_PStrCR( MCA_PROG_NAME );
Print_PStrCR( MCA_DATUM );
Print_PStrCR( MCA_VERSION );
Print_PStrCR( MCA_AUTOR );

ullNow = gu32T2_Ticks = 0;

//INITs fuer  Midi in main.c
gstMidi.u8Channel = DEFAULT_CHANNEL	;		
gstMidi.u8Intrument = DEFAULT_INSTRUMENT;	
gstMidi.u8Dynamic = DEFAULT_VELOCITY;
gu8MidiStatus = STATUS_DUR;

// ************ MAIN LOOP FOR EVER *********************
for (;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
	{	
	sei();
 	wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	//SWuart_putc( 0xAA );
	//PULS_PER_10TEL_SEc_T2
	//PULS_100MS_TICK_T2
	//PULS_PER_SEcONDTick_T2
	//PULS_500MS_Tick_T2 PULS_250MS_TICK_T2
	//DDRA = 0;
	
	ScanSensor();
	ScanKlavier();
	
/*
	DDRB=0xFF;	
	PORTB = (gsKlavier.u64Note >> 24) & 0xFF;
	PORTC = (gsKlavier.u64Note >> 32) & 0xFF;
*/	
	if( GetTickDifference(ullNow) > 244)
		{
		
		ullNow = gu32T2_Ticks; //Zeit merken !!
		
		
/*
if( u8Toggle++ )
	{
	PORTC = ((FUNTESBYTEA5 & FUENFTES_BYTE_MASK) >> 32)  & 0xFF;
	}
else
	{
	PORTC = ((FUNTESBYTE5A & FUENFTES_BYTE_MASK) >> 32)  & 0xFF;
	};		
	u8Toggle %= 2;
*/		

if( gu8ProgMode & MODE_TEST_SHIFTBORD )
	{
	PrintLongCR(gsKlavier.u64Note & 0xFF);	
	PrintLongCR((gsKlavier.u64Note >> 8) & 0xFF);	
	PrintLongCR((gsKlavier.u64Note >> 16) & 0xFF);	
	PrintLongCR((gsKlavier.u64Note >> 24) & 0xFF);	
	PrintLongCR((gsKlavier.u64Note >> 32) & 0xFF);	
	PrintCR();
	};

if( gu8ProgMode & MODE_TEST_KLAVIERTON )
	{
		TxMidi_ProgChange( gstMidi.u8Intrument );
		if( u8Toggle )
			{
			u8Toggle = 0;
			SendMidi_ON( 0x3C );
			}
		else
			{
			u8Toggle = 1;
			SendMidi_OFF( 0x3c );
			};
	};
		//ende von Hier kann was gemacht werden jede Sekunde
		};

/*	
	if(BOARD_HW_PORT_IN & KEY1_MASKE)
		{
		BOARD_HW_PORT_OUT |= LED1_MASKE;
		if( gstKey.ucKeyStat[0] & KEYSTAT_RELEASED )
			{
			gstMidi.u8Intrument++;
			TxMidi_ProgChange( gstMidi.u8Intrument );
			PrintLongCR( gstMidi.u8Intrument );				
			gstKey.ucKeyStat[0] = 0;
			};
		}
	else
		{
		BOARD_HW_PORT_OUT &= ~LED1_MASKE;
		gstKey.ucKeyStat[0] = KEYSTAT_RELEASED;
		};
	
	if(BOARD_HW_PORT_IN & KEY2_MASKE)
		{
		BOARD_HW_PORT_OUT |= LED2_MASKE;
		if( gstKey.ucKeyStat[1] & KEYSTAT_RELEASED )
			{						
			gstMidi.u8Intrument--;
			TxMidi_ProgChange( gstMidi.u8Intrument );
			PrintLongCR( gstMidi.u8Intrument );
			gstKey.ucKeyStat[1] = 0;			
			};
		}
	else
		{
		BOARD_HW_PORT_OUT &= ~LED2_MASKE;
		gstKey.ucKeyStat[1] = KEYSTAT_RELEASED;
		};
		
		
	if(BOARD_HW_PORT_IN & KEY3_MASKE)
		{
		BOARD_HW_PORT_OUT |= SUMMER_MASKE;
		if( gstKey.ucKeyStat[2] & KEYSTAT_RELEASED )
			{
			gstKey.ucKeyStat[2] = 0;
			//??		
			};
		}
	else
		{
		BOARD_HW_PORT_OUT &= ~SUMMER_MASKE;
		gstKey.ucKeyStat[2] = KEYSTAT_RELEASED;
		};
*/
	//UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
	UART_TXRX_Check();
	}; // main   END END *************
};
// ******************* MAIN END ********************************************


